/* ANSI -*- C -*- */

#include <stdlib.h>
#include <stdio.h>
#include <tcl.h>
#include <tk.h>

Tcl_Interp * theinterp;
Tk_Window mainwin;

int debug = 0;
int log = 0;

char textline[6+1] = "SIGNAL";
char topnumbers[8+1] = "88888888";
char largenumbers[4+1] = "8888";
char smallnumbers[2+1] = "88";

#define STATUSTERMINATED 0
#define STATUSHALT 1
#define STATUSWAIT -1

#define SIGPRESENT	1
#define SIGUNKNOWN	0
#define SIGABSENT	-1

/* The ## concatenates the variablename into sig_signal */

#define setpresent(signal) *((sig_ ## signal).sigpres) = SIGPRESENT;

#define sigpres(signal) *((sig_ ## signal).sigpres) == SIGPRESENT
#define sigval(signal) *((sig_ ## signal).sigval)

#define settextline012(a,b,c) \
textline[0] = a; textline[1] = b; textline[2] = c

typedef struct {
  char * name;
  int globalinput;
  char * sigpres;
  int * sigval;
} sig_t;

extern sig_t sig_TENTHSECOND;
extern sig_t sig_MODE, sig_ADJUST, sig_REVERSE, sig_FORWARD;
extern sig_t sig_DISPLAY_MODE;
#define Time_mode 0
#define Time_adjust_mode 1
#define Alarm_mode 2
#define Alarm_adjust_mode 3
#define Dual_mode 4
#define Dual_adjust_mode 5
#define Timer_mode 6
#define Timer_adjust_mode 7
#define Stopwatch_mode 8

extern sig_t sig_DISPLAY_FIELD;

extern sig_t sig_MAIN_SECOND, sig_MAIN_MINUTE, sig_MAIN_HOUR;
extern sig_t sig_MAIN_DAY, sig_MAIN_DATE, sig_MAIN_MONTH, sig_MAIN_YEAR;

extern sig_t sig_DUAL_SECOND, sig_DUAL_MINUTE, sig_DUAL_HOUR;
extern sig_t sig_DUAL_DATE, sig_DUAL_MONTH;

extern sig_t sig_ALARM_MONTH, sig_ALARM_DATE, sig_ALARM_HOUR, sig_ALARM_MINUTE;

extern sig_t sig_TIMER_HOUR, sig_TIMER_MINUTE, sig_TIMER_SECOND;

extern sig_t sig_STOPWATCH_TENTHSECOND, sig_STOPWATCH_SECOND;
extern sig_t sig_STOPWATCH_MINUTE, sig_STOPWATCH_HOUR;
extern sig_t sig_STOPWATCH_FROZEN;

extern sig_t sig_UPDATE;

extern sig_t sig_ALARMACTIVE;

extern sig_t sig_FLASH;

void setdisplay(Tcl_Interp * interp) {
  Tcl_VarEval( interp, ".display.textline configure -text \"", textline,
	       "\"" , (char *) NULL );
  Tcl_VarEval( interp, ".display.topnumbers configure -text \"", topnumbers,
	       "\"" , (char *) NULL );
  Tcl_VarEval( interp, ".display.largenumbers configure -text \"",
	       largenumbers, "\"" , (char *) NULL );
  Tcl_VarEval( interp, ".display.smallnumbers configure -text \"",
	       smallnumbers, "\"" , (char *) NULL );
}

void dotick() {

  int tmp;

#if 0
  printf("%d ",simtick(debug));
#else
  simtick(debug);
#endif

  if ( sigpres(ALARMACTIVE) ) printf("\a");

  if ( sigpres(UPDATE) ) {

    switch ( sigval(DISPLAY_MODE) ) {

    case Time_mode: case Time_adjust_mode:
      switch( sigval(MAIN_DAY) ) {
      case 0 : settextline012('S','U','N'); break;
      case 1 : settextline012('M','O','N'); break;
      case 2 : settextline012('T','U','E'); break;
      case 3 : settextline012('W','E','D'); break;
      case 4 : settextline012('T','H','U'); break;
      case 5 : settextline012('F','R','I'); break;
      case 6 : settextline012('S','A','T'); break;
      }
      textline[3] = '\'';
      textline[4] = '0' + sigval(MAIN_YEAR) / 10;
      textline[5] = '0' + sigval(MAIN_YEAR) % 10;

      topnumbers[0] = topnumbers[1] = topnumbers[2] = topnumbers[3] = ' ';
      topnumbers[4] = sigval(MAIN_MONTH) < 10 ?
	' ' : '0' + sigval(MAIN_MONTH) / 10;
      topnumbers[5] = '0' + sigval(MAIN_MONTH) % 10;
      topnumbers[6] = '-';
      topnumbers[7] = sigval(MAIN_DATE) < 10 ?
	' ' : '0' + sigval(MAIN_DATE) / 10;
      topnumbers[8] = '0' + sigval(MAIN_DATE) % 10;

      largenumbers[0] = sigval(MAIN_HOUR) < 10 ?
	' ' : '0' + sigval(MAIN_HOUR) / 10;
      largenumbers[1] = '0' + sigval(MAIN_HOUR) % 10;
      largenumbers[2] = '0' + sigval(MAIN_MINUTE) / 10;
      largenumbers[3] = '0' + sigval(MAIN_MINUTE) % 10;

      smallnumbers[0] = '0' + sigval(MAIN_SECOND) / 10;
      smallnumbers[1] = '0' + sigval(MAIN_SECOND) % 10;
      break;

    case Alarm_mode: case Alarm_adjust_mode:
      textline[0] = 'A'; textline[1] = 'L'; textline[2] = 'A';
      textline[3] = 'R'; textline[4] = 'M'; textline[5] = ' ';
      topnumbers[0] = topnumbers[1] = topnumbers[2] = topnumbers[3] = ' ';
      tmp = sigval(ALARM_MONTH);
      if ( tmp == 0 ) {
	topnumbers[4] = topnumbers[5] = '-';
      } else {
	topnumbers[4] = tmp < 10 ? ' ' : '0' + tmp / 10;
	topnumbers[5] = '0' + tmp % 10;
      }
      topnumbers[6] = '-';
      tmp = sigval(ALARM_DATE);
      if ( tmp == 0 ) {
	topnumbers[7] = topnumbers[8] = '-';
      } else {
	topnumbers[7] = tmp < 10 ? ' ' : '0' + tmp / 10;
	topnumbers[8] = '0' + tmp % 10;
      }

      tmp = sigval(ALARM_HOUR);
      largenumbers[0] = tmp < 10 ? ' ' : '0' + tmp / 10;
      largenumbers[1] = '0' + tmp % 10;

      tmp = sigval(ALARM_MINUTE);
      largenumbers[2] = '0' + tmp / 10;
      largenumbers[3] = '0' + tmp % 10;

      smallnumbers[0] = smallnumbers[1] = ' ';

      break;

    case Dual_mode: case Dual_adjust_mode:
      textline[0] = 'D'; textline[1] = 'U'; textline[2] = 'A';
      textline[3] = 'L'; textline[4] = textline[5] = ' ';

      topnumbers[0] = topnumbers[1] = topnumbers[2] = topnumbers[3] = ' ';
      topnumbers[4] = sigval(DUAL_MONTH) < 10 ?
	' ' : '0' + sigval(DUAL_MONTH) / 10;
      topnumbers[5] = '0' + sigval(DUAL_MONTH) % 10;
      topnumbers[6] = '-';
      topnumbers[7] = sigval(DUAL_DATE) < 10 ?
	' ' : '0' + sigval(DUAL_DATE) / 10;
      topnumbers[8] = '0' + sigval(DUAL_DATE) % 10;

      largenumbers[0] = sigval(DUAL_HOUR) < 10 ?
	' ' : '0' + sigval(DUAL_HOUR) / 10;
      largenumbers[1] = '0' + sigval(DUAL_HOUR) % 10;
      largenumbers[2] = '0' + sigval(DUAL_MINUTE) / 10;
      largenumbers[3] = '0' + sigval(DUAL_MINUTE) % 10;

      smallnumbers[0] = '0' + sigval(MAIN_SECOND) / 10;
      smallnumbers[1] = '0' + sigval(MAIN_SECOND) % 10;
      break;

    case Timer_mode: case Timer_adjust_mode:
      textline[0] = 'T'; textline[1] = 'I'; textline[2] = 'M';
      textline[3] = 'E'; textline[4] = 'R'; textline[5] = ' ';

      topnumbers[0] = sigval(MAIN_HOUR) < 10 ? ' ' :
	'0' + sigval(MAIN_HOUR) / 10;
      topnumbers[1] = '0' + sigval(MAIN_HOUR) % 10;

      topnumbers[2] = '0' + sigval(MAIN_MINUTE) / 10;
      topnumbers[3] = '0' + sigval(MAIN_MINUTE) % 10;
      topnumbers[4] = topnumbers[5] = topnumbers[6] = topnumbers[7] =
	topnumbers[8] = ' ';

      largenumbers[0] = sigval(TIMER_HOUR) < 10 ?
	' ' : '0' + sigval(TIMER_HOUR) / 10;
      largenumbers[1] = '0' + sigval(TIMER_HOUR) % 10;

      largenumbers[2] = '0' + sigval(TIMER_MINUTE) / 10;
      largenumbers[3] = '0' + sigval(TIMER_MINUTE) % 10;

      smallnumbers[0] = '0' + sigval(TIMER_SECOND) / 10;
      smallnumbers[1] = '0' + sigval(TIMER_SECOND) % 10;

      break;

    case Stopwatch_mode:

      if ( sigpres(STOPWATCH_FROZEN) ) {
	textline[0] = 'S'; textline[1] = 'P'; textline[2] = 'L';
        textline[3] = 'I'; textline[4] = 'T'; textline[5] = ' ';
      } else {
	textline[0] = 'S'; textline[1] = 'T'; textline[2] = 'O';
        textline[3] = 'P'; textline[4] = '-'; textline[5] = 'W';
      }

      topnumbers[0] = sigval(MAIN_HOUR) < 10 ? ' ' :
	'0' + sigval(MAIN_HOUR) / 10;
      topnumbers[1] = '0' + sigval(MAIN_HOUR) % 10;

      topnumbers[2] = '0' + sigval(MAIN_MINUTE) / 10;
      topnumbers[3] = '0' + sigval(MAIN_MINUTE) % 10;

      topnumbers[4] = topnumbers[5] = ' ';

      topnumbers[6] = '0' + sigval(STOPWATCH_TENTHSECOND);
      topnumbers[7] = '0';
      topnumbers[8] = ' ';

      largenumbers[0] = sigval(STOPWATCH_HOUR) < 10 ?
	' ' : '0' + sigval(STOPWATCH_HOUR) / 10;
      largenumbers[1] = '0' + sigval(STOPWATCH_HOUR) % 10;
      largenumbers[2] = '0' + sigval(STOPWATCH_MINUTE) / 10;
      largenumbers[3] = '0' + sigval(STOPWATCH_MINUTE) % 10;
      smallnumbers[0] = '0' + sigval(STOPWATCH_SECOND) / 10;
      smallnumbers[1] = '0' + sigval(STOPWATCH_SECOND) % 10;
      break;

    }

    if ( sigpres(FLASH) )
      switch( sigval(DISPLAY_MODE) ) {
      case Time_adjust_mode:
	switch ( sigval(DISPLAY_FIELD) ) {
	case 0: smallnumbers[0] = smallnumbers[1] = '#'; break;
	case 1: largenumbers[0] = largenumbers[1] = '#'; break;
	case 2: largenumbers[2] = largenumbers[3] = '#'; break;
	case 3: textline[0] = textline[1] = textline[2] = '#'; break;
	case 4: textline[4] = textline[5] = '#'; break;
	case 5: topnumbers[4] = topnumbers[5] = '#'; break;
	case 6: topnumbers[7] = topnumbers[8] = '#'; break;
	}
	break;

      case Alarm_adjust_mode: case Dual_adjust_mode:
	switch( sigval(DISPLAY_FIELD) ) {
	case 0: largenumbers[0] = largenumbers[1] = '#'; break;
	case 1: largenumbers[2] = largenumbers[3] = '#'; break;
	case 2: topnumbers[4] = topnumbers[5] = '#'; break;
	case 3: topnumbers[7] = topnumbers[8] = '#'; break;
	}
	break;

      case Timer_adjust_mode:
	switch( sigval(DISPLAY_FIELD) ) {
	case 0: largenumbers[0] = largenumbers[1] = '#'; break;
	case 1: largenumbers[2] = largenumbers[3] = '#'; break;
	}
	break;
	
      default: break;
      }

    setdisplay(theinterp);

  }

}

int modepressedCmd( ClientData clientData, Tcl_Interp * interp,
		   int argc, char *argv[] ) {
  clearsignals();

  setpresent(MODE);

  if ( log ) printf("p MODE\nt\n");

  dotick();

  return TCL_OK;
}

int adjustpressedCmd( ClientData clientData, Tcl_Interp * interp,
		     int argc, char *argv[] ) {

  clearsignals();

  setpresent(ADJUST);

  if ( log ) printf("p ADJUST\nt\n");

  dotick();

  return TCL_OK;
}

int forwardpressedCmd( ClientData clientData, Tcl_Interp * interp,
		      int argc, char *argv[] ) {
  clearsignals();

  setpresent(FORWARD);

  if ( log ) printf("p FORWARD\nt\n");

  dotick();

  return TCL_OK;
}

int reversepressedCmd( ClientData clientData, Tcl_Interp * interp,
		      int argc, char *argv[] ) {

  clearsignals();

  setpresent(REVERSE);

  if ( log ) printf("p REVERSE\nt\n");
  
  dotick();

  return TCL_OK;
}

void tenthsecondproc( ClientData clientData ) {
  Tk_CreateTimerHandler( 100, tenthsecondproc, (ClientData *) NULL );

  clearsignals();

  setpresent(TENTHSECOND);

  if ( log ) printf("p TENTHSECOND\nt\n");

  dotick();
}

main(int argc, char *argv[]) {
  int code;

  if (argc >= 3 && argv[1][0] == '-' && argv[1][1] == 'd') debug = atoi(argv[2]);

  if (argc >= 2 && argv[1][0] == '-' && argv[1][1] == 'l' ) log = 1;

  theinterp = Tcl_CreateInterp();

  mainwin = Tk_CreateMainWindow( theinterp, 0, "watch", "Tk" );
  Tcl_Init(theinterp);
  Tk_Init(theinterp);

  Tcl_CreateCommand( theinterp, "modepressed", modepressedCmd,
		    (ClientData *) NULL, (Tcl_CmdDeleteProc *) NULL );
  Tcl_CreateCommand( theinterp, "adjustpressed", adjustpressedCmd,
		    (ClientData *) NULL, (Tcl_CmdDeleteProc *) NULL );
  Tcl_CreateCommand( theinterp, "forwardpressed", forwardpressedCmd,
		    (ClientData *) NULL, (Tcl_CmdDeleteProc *) NULL );
  Tcl_CreateCommand( theinterp, "reversepressed", reversepressedCmd,
		    (ClientData *) NULL, (Tcl_CmdDeleteProc *) NULL );

  Tk_CreateTimerHandler( 1000, tenthsecondproc, (ClientData *) NULL );

  initialize();		/* the esterel code */

  code = Tcl_EvalFile( theinterp, "watch.tcl" );

  Tk_MainLoop();

  exit(0);

}
